
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>开放api接口签名验证 / 憋错料</title>

    <meta name="description" content="开放api接口签名验证 不要急,源代码分享在最底部,先问大家一个问题,你在写开放的API接口时是如何保证数据的安全性的?先来看看有哪些安全性问题在开放的api接口中,我们通过http Post或者Get方式请求服务器的时候,会面临着许多的安全性问题,例如: 请求来源(身份)是否合法? 请求参数被篡改? 请求的唯一性(不可复制) 为了保证数据在通信时的安全性,我们可以采用参数签名的方式来进行相关验证. 案列分析 我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析: 客户端: 以下简称app 后">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">开放api接口签名验证</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>不要急，源代码分享在最底部，先问大家一个问题，你在写开放的API接口时是如何保证数据的安全性的？先来看看有哪些安全性问题在开放的api接口中，我们通过http Post或者Get方式请求服务器的时候，会面临着许多的安全性问题，例如：</p>
<ol>
<li>请求来源(身份)是否合法？</li>
<li>请求参数被篡改？</li>
<li>请求的唯一性(不可复制)</li>
</ol>
<p>为了保证数据在通信时的安全性，我们可以采用参数签名的方式来进行相关验证。</p>
<p><strong>案列分析</strong></p>
<p>我们通过给某&nbsp;[移动端(app)]&nbsp;写&nbsp;[后台接口(api)]&nbsp;的案例进行分析：</p>
<p>客户端： 以下简称app</p>
<p>后台接口：以下简称api</p>
<p>我们通过app查询产品列表这个操作来进行分析：</p>
<p>app中点击查询按钮==》调用api进行查询==》返回查询结果==&gt;显示在app中</p>
<p><em>上代码啦 -_-！</em></p>
<p><strong>一、不进行验证的方式</strong></p>
<p>api查询接口：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnhpdW1pLnVzL3htaS91YS94alVHL2kvZGQwMTZmYjY4NDQwYjk1ZjRjMmNlNjYwZGQwYzMyNDktc3pfNjIyNS5wbmdAMWxfNjQwdy5wbmc=.jpg" /></p>
<p>app调用：http://api.test.com/getproducts?参数1=value1.......</p>
<p>如上，这种方式简单粗暴，通过调用getproducts方法即可获取产品列表信息了，但是 这样的方式会存在很严重的安全性问题，没有进行任何的验证，大家都可以通过这个方法获取到产品列表，导致产品信息泄露。<br />那么，如何验证调用者身份呢？如何防止参数被篡改呢？</p>
<p><strong>二、MD5参数签名的方式</strong></p>
<p>我们对api查询产品接口进行优化：</p>
<p>1.给app分配对应的key、secret</p>
<p>2.Sign签名，调用API&nbsp;时需要对请求参数进行签名验证，签名方式如下：</p>
<p>a.&nbsp;按照请求参数名称将所有请求参数按照字母先后顺序排序得到：keyvaluekeyvalue...keyvalue&nbsp;&nbsp;字符串如：将arong=1,mrong=2,crong=3&nbsp;排序为：arong=1,&nbsp;crong=3,mrong=2&nbsp;&nbsp;然后将参数名和参数值进行拼接得到参数字符串：arong1crong3mrong2。</p>
<p>b.&nbsp;将secret加在参数字符串的头部后进行MD5加密&nbsp;,加密后的字符串需大写。即得到签名Sign</p>
<p>新api接口代码:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnhpdW1pLnVzL3htaS91YS94alVHL2kvYWViZjM0M2ViZTkyODE5ZDAwMWFhNmEwOTZhMTkxYTUtc3pfOTc0Ny5wbmdAMWxfNjQwdy5wbmc=.jpg" /></p>
<p>app调用：http://api.test.com/getproducts?<strong>key</strong>=app_key&amp;<strong>sign</strong>=BCC7C71CF93F9CDBDB88671B701D8A35&amp;参数1=value1&amp;参数2=value2.......</p>
<p>注：secret&nbsp;仅作加密使用,&nbsp;为了保证数据安全请不要在请求参数中使用。</p>
<p>如上，优化后的请求多了key和sign参数，这样请求的时候就需要合法的key和正确签名sign才可以获取产品数据。这样就解决了身份验证和防止参数篡改问题，如果请求参数被人拿走，没事，他们永远也拿不到secret,因为secret是不传递的。再也无法伪造合法的请求。</p>
<p>但是...这样就够了吗？细心的同学可能会发现，如果我获取了你完整的链接，一直使用你的key和sign和一样的参数不就可以正常获取数据了...-_-!是的，仅仅是如上的优化是不够的</p>
<p><strong>请求的唯一性：</strong></p>
<p>为了防止别人重复使用请求参数问题，我们需要保证请求的唯一性，就是对应请求只能使用一次，这样就算别人拿走了请求的完整链接也是无效的。<br />唯一性的实现：在如上的请求参数中，我们加入时间戳 ：timestamp（yyyyMMddHHmmss），同样，时间戳作为请求参数之一，也加入sign算法中进行加密。</p>
<p>新的api接口：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLnhpdW1pLnVzL3htaS91YS94alVHL2kvNWI4N2I2OGM1OTMyZTFkODlmYTQwODVlYzcxYmJkMDMtc3pfMTA2MjcucG5nQDFsXzY0MHcucG5n.jpg" /></p>
<p>app调用：<br />http://api.test.com/getproducts?<strong>key</strong>=app_key&amp;<strong>sign</strong>=BCC7C71CF93F9CDBDB88671B701D8A35&amp;<strong>timestamp</strong>=201603261407&amp;参数1=value1&amp;参数2=value2.......</p>
<p>如上，我们通过timestamp时间戳用来验证请求是否过期。这样就算被人拿走完整的请求链接也是无效的。</p>
<p><strong>Sign签名安全性分析：</strong></p>
<p>通过上面的案例，我们可以看出，安全的关键在于参与签名的secret，整个过程中secret是不参与通信的，所以只要保证secret不泄露，请求就不会被伪造。</p>
<p>总结</p>
<p>上述的Sign签名的方式能够在一定程度上防止信息被篡改和伪造，保障通信的安全，这里使用的是MD5进行加密，当然实际使用中大家可以根据实际需求进行自定义签名算法，比如：RSA，SHA等。</p>
<p>From:&nbsp;http://www.cnblogs.com/codelir/p/5327462.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 02:08:17 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>开放api接口签名验证的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXvw1k3.html" rel="bookmark">【转】开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不要急,源代码分享在最底部,先问大家一个问题,你在写开放的API接口时是如何保证数据的安全性的?先来看看有哪些安全性问题在开放的api接口中,我们通过http Post或者Get方式请求服务器的时候,会面临着许多的安全性问题,例如: 1. 请求来源(身份)是否合法? 2. 请求参数被篡改? 3. 请求的唯一性(不可复制) 为了保证数据在通信时的安全性,我们可以采用参数签名的方式来进行相关验证. 案列分析 我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析: 客户端:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49gw5p0.html" rel="bookmark">springcloud提供开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.MD5参数签名的方式 我们对api查询产品接口进行优化: 1.给app分配对应的key.secret 2.Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:arong=1, crong=3,mrong=2  然后将参数名和参数值进行拼接得到参数字符串:arong1crong3mrong			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1jmO4.html" rel="bookmark">常用API接口签名验证参考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目中常用的API接口签名验证方法: 1. 给app分配对应的key.secret2. Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:arong=1, crong=3,mrong=2  然后将参数名和参数值进行拼接得到参数字符串:arong1crong3mrong2: b. 将secr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qE6GN3.html" rel="bookmark">Android测试工具ThreadingTest开放API接口说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ThreadingTest(简称TT)第一期是一款Android白盒测试工具,使用离线检测的方式,在保护用户源代码的基础上,运用插装.第五代覆盖率等技术,为开发工程师与测试工程师提供一套高效可量化.可视化的交流工具.对比其它测试工具,TT在自动化测试时,会对应测试用例自动生成测试用例和代码之间的关系以及函数覆盖率,并且以TT自带的双向追溯图进行展示,在整个自动化测试进行过程中,TT还会以示波器界面可视化的监控整个自动化测试中每时每刻获取的测试数据. 基于其它测试工具测试时,TT还开放了API接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02wjwn3.html" rel="bookmark">开放API接口 笑话、天气、新闻</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				笑话接口示例: http://api.1-blog.com/biz/bizserver/xiaohua/list.do?maxXhid=1000000&amp;size=1&amp;minXhid=6 开放API接口 笑话.天气.新闻 博客分类: 其它 API新闻笑话天气开放API 闲来无事,弄了几个API接口,分享给同样需(闲的)要(没事儿)的人吧 API接口都是HTTP形式的,数据都是json格式,支持ajax调用(已开放所有域名访问) PS:演示网站http://1-blog.com 使用的人麻烦加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Oklg0.html" rel="bookmark">转载-常用API接口签名验证参考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址: http://www.cnblogs.com/hnsongbiao/p/5478645.html 写的很好,就做个笔记了.感谢作者! 项目中常用的API接口签名验证方法: 1. 给app分配对应的key.secret2. Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:aro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xz8wN4.html" rel="bookmark">开放API接口及其安全性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开放出来给别人调用的API接口是就是开放API接口. 弱点: 数据窃取 用户的密码等信息被不轨之人窃取,登录账号发布敏感信息,盗刷等. 数据篡改 提交的数据被抓包后进行篡改再提交. 数据泄露 爬虫将业务数据甚至核心数据抓取,直接或者间接造成损失. RSA/DES加密 MD5混淆 TOKEN令牌 有令牌才能通过,没有令牌则不能通过 加密分为对称加密和非对称加密 对称加密有:DES,AES 加密和解密是使用同一套秘钥 非对称加密有:RSA 公钥和私钥 公钥加密,私钥解密 RSA可以用来加密和签名 H			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bzBmp0.html" rel="bookmark">几个开放API接口 笑话、天气、新闻</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闲来无事,弄了几个API接口,分享给同样需(闲的)要(没事儿)的人吧API接口都是HTTP形式的,数据都是json格式,支持ajax调用(已开放所有域名访问) 笑话API 说明:调用后返回笑话列表,可以在参数中设置已经获取的最大笑话ID和最小笑话ID,返回结果会返回新的笑话(目前大概1w条左右,持续增加中)使用方式请求地址:http://114.215.158.105:8080/bizserver/xiaohua/list.do示例 http://114.215.158.105:8080/htm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dRaD64.html" rel="bookmark">远程开户系统开放API接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如今随着智能识别技术的成熟和商用,金融领域也开始逐渐试水&quot;远程开户&quot;.从OCR身份证识别到人脸识别,到如今市场上即将出现完整的远程开户系统,除了需要成熟的技术做支撑外,还需要对市场有着前瞻性的眼光. 这套远程开户系统包含了OCR身份证识别技术.银行卡识别技术.人脸识别等智能识别技术.即利用身份证识别快速采集验证用户身份,并通过联网核查进行验证身份信息,用来核实用户的真实身份;然后利用银行卡识别一键绑定银行卡,再辅以视频人脸识别进行身份进一步验证,确保开户者与证件持有者为同一人,做到人证			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35pzn0.html" rel="bookmark" class="title">【深度分解】听趣拍云产品经理剖析视频基础知识（2）</a>
					<div>
						&quot;随着技术的不断进步,视频技术的制作加工门槛逐渐降低,信息资源的不断增长,同时由于视频信息内容更加丰富完整的先天优势,在近年来已经逐渐成为主流.在基础知识(1)里面已经讲了模拟时代和数字化时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4ALo53.html" rel="bookmark" class="title">联考8&period;5</a>
					<div>
						day2的暴力分拿的还算稳,然而只会打暴力...... T1数论题, 30分暴力直接走人 T2很像一个DP,先打了暴力留着对拍,结果刚了两个小时毛都没写出来,暴力也萎了...... T3最小生成树啊, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bANoM.html" rel="bookmark" class="title">有返回值的多线程demo</a>
					<div>
						package com.jimmy.demo.util; import java.util.HashMap;import java.util.concurrent.*;import java.util ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGeYB3.html" rel="bookmark" class="title">【剑指offer】统计0到n之间1的个数&lbrack;数学&rsqb;</a>
					<div>
						问题描述 给定一个十进制整数N,求出从1到N的所有整数中出现&quot;1&quot;的个数. 例如:N=2时 1,2出现了1个 &quot;1&quot; . N=12时 1,2,3,4,5,6,7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQNeB3.html" rel="bookmark" class="title">C&plus;&plus;数组类型与函数类型</a>
					<div>
						之所以将C++的数组类型与函数类型拿到一块说,是因为两者在很多地方都一样. 首先,声明形式上类似: 数组类型:  type [num]                                  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pePdJM.html" rel="bookmark" class="title">CentOS常见问题</a>
					<div>
						1.kubernetes1.5.1安装 参考文献:http://lizhiyuan.blog.51cto.com/1343931/1890692 另外一篇文章:http://www.cnblogs.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47NOPk3.html" rel="bookmark" class="title">跟随鼠标的DIV和一连串跟随鼠标的DIV</a>
					<div>
						1. 跟随鼠标的DIV 1 window.onmousemove = function(ev) { 2 //浏览器兼容 3 var oEvent = ev || event; 4 var oDiv = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjzpL0.html" rel="bookmark" class="title">CENTOS下搭建SVN服务器&lpar;转&rpar;</a>
					<div>
						1.安装svn yum install -y subversion 2.验证安装是否成功 svnserve --version 3.创建svn版本库 mkdir svn svnadmin create ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62XvGM.html" rel="bookmark" class="title">第一天：网页制作基础</a>
					<div>
						第一章:网页制作基础 2016-7.18 20:40---23:42 1-1 网站的概述 网页与网站网站是由许多的网页构成的 新浪网是网站浏览器:国外流行的浏览器为火狐,国内为360安全浏览器,用最多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wylwYM.html" rel="bookmark" class="title">python  calendar标准库基础学习</a>
					<div>
						# -*- coding: utf-8 -*-# 作者:新手__author__ = 'Administrator'#标准库:日期时间基础学习:calendar:处理日期#例1import calen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qEV8N3.html" rel="bookmark" class="title">Nginx简介与源码编译安装</a>
					<div>
						1.Nginx简介 Nginx官方站点:http://nginx.orgNginx官方文档:http://nginx.org/en/docs Nginx是一款免费,开源,轻量级高性能的网站服务器(ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZGgg3.html" rel="bookmark" class="title">第六课－Android四大组件之Activity</a>
					<div>
						Activity是Android四大组件之一,它是个控制类,主要控制界面的加载显示,用户交互处理,数据的获取,数据的传送等.在它的onCreate方法中的setContentView方法就是来加载一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglYdr0.html" rel="bookmark" class="title">div内容上下左右居中</a>
					<div>
						&lt;!-- 遮罩层 --&gt; &lt;div id=&quot;test&quot; &gt; &lt;div style=&quot;position:absolute;top:50%;le ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoLx7P0.html" rel="bookmark" class="title">隐藏元素的URL是否加载</a>
					<div>
						结论chrome: 隐藏的元素及其包含的背景图不会加载(样式隐藏元素的当前背景会加载). hover的背景图不会加载,当hover时才加载. 隐藏的img或img在隐藏的元素内也会加载. 没有匹配的样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8l7KM.html" rel="bookmark" class="title">struts2 修改action的后缀</a>
					<div>
						struts2 的默认后缀是 .action 虽然很直观,但是很烦琐.很多人喜欢将请求的后缀改为 .do 在struts2中修改action后缀有两种比较简单的办法: 一.在 struts.prope ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49eEKW4.html" rel="bookmark" class="title">vsftpd环境下的创建本地yum源镜像</a>
					<div>
						1.安装FTP软件 # yum install -y vsftpd*    安装FTP软件 # service vsftpd start    启动FTP服务 #chkconfig --add vsf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nnxm84.html" rel="bookmark" class="title">java自定义ArrayList排序， 大神略过</a>
					<div>
						一个list里面有两种对象,现在有个需求必须对不同的对象的日期来排序,以下是代码 /** *@author 肖华 [email protected] */ List&lt;Message&gt; me ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWe9j0.html" rel="bookmark" class="title">BaseAdapter&amp;lt&semi;T&amp;gt&semi;   重写 createViewFromResource实现界面，刷新，加载，移除</a>
					<div>
						1 import java.util.ArrayList; 2 import java.util.List; 4 import android.content.Context; 5 import an ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oy9dZM.html" rel="bookmark" class="title">备份和恢复vs2013和vs2015帮助查看器中的书签</a>
					<div>
						vs2013 和 vs2015的帮助文档是使用help viewer来查看的,但是官方并没有提供备份和恢复书签的功能,需要手动操作. vs2013书签文件保存位置: %USERPROFILE%\App ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDaJG0.html" rel="bookmark" class="title">群策群力：传智&OpenCurlyDoubleQuote;小马&rdquo;齐过河&mdash;&mdash;成都传智播客校园新闻</a>
					<div>
						日前,传智播客成都Java培训中心就业班同学开展了一场趣味游戏--小马过河.游戏中,传智学员集思广益,互帮互助,大家的表现真是可圈可点. 班主任倪老师正在讲解游戏规则,小伙伴们快来围观呀. 游戏规定, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
